/*******************************************************
 *  Unit test for the date class
 *
 * test date relational operators
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   date   d0(9, 6, 2019);
   date   d1(9, 6, 2019);
   date   d2(7, 8, 2019);

   //  equal dates

   std::cout << d0 << " == " << d1 << " = " << (d0 == d1) << "\n";
   assert((d0 == d1) == true);

   std::cout << d0 << " != " << d1 << " = " << (d0 != d1) << "\n";
   assert((d0 != d1) == false);

   std::cout << d0 << " < " << d1 << " = " << (d0 < d1) << "\n";
   assert((d0 < d1) == false);

   std::cout << d0 << " <= " << d1 << " = " << (d0 <= d1) << "\n";
   assert((d0 <= d1) == true);

   std::cout << d0 << " > " << d1 << " = " << (d0 > d1) << "\n";
   assert((d0 > d1) == false);

   std::cout << d0 << " >= " << d1 << " = " << (d0 >= d1) << "\n";
   assert((d0 >= d1) == true);

   //  unequal dates

   std::cout << d0 << " == " << d2 << " = " << (d0 == d2) << "\n";
   assert((d0 == d2) == false);

   std::cout << d0 << " != " << d2 << " = " << (d0 != d2) << "\n";
   assert((d0 != d2) == true);

   std::cout << d0 << " < " << d2 << " = " << (d0 < d2) << "\n";
   assert((d0 < d2) == true);

   std::cout << d0 << " <= " << d2 << " = " << (d0 <= d2) << "\n";
   assert((d0 <= d2) == true);

   std::cout << d0 << " > " << d2 << " = " << (d0 > d2) << "\n";
   assert((d0 > d2) == false);

   std::cout << d0 << " >= " << d2 << " = " << (d0 >= d2) << "\n";
   assert((d0 >= d2) == false);

   return 0;
}

