/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 51 "dateyacc.y" /* yacc.c:339  */

#ifdef RCSIDENT
static char rcsident[] = "$Header: /cvsroot/lib/AXE/src/dateyacc.y,v 1.2 2002-09-28 06:58:45 arjen Exp $";
#endif /*RCSIDENT*/

#include <stdio.h>
#include "parsedate.h"
struct parseddate yyans;

int yylex();

/* No error routine is needed here. */
#define yyerror(s)

#line 81 "dateyacc.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DAY_NAME = 258,
    MONTH_NAME = 259,
    NUM9 = 260,
    NUM23 = 261,
    NUM59 = 262,
    NUM99 = 263,
    NUM2359 = 264,
    NUM9999 = 265,
    NUM235959 = 266,
    NUM991231 = 267,
    NUM99991231 = 268,
    NUM999999 = 269,
    AMPM = 270,
    STD_ZONE = 271,
    DST_ZONE = 272,
    DST_SUFFIX = 273
  };
#endif
/* Tokens.  */
#define DAY_NAME 258
#define MONTH_NAME 259
#define NUM9 260
#define NUM23 261
#define NUM59 262
#define NUM99 263
#define NUM2359 264
#define NUM9999 265
#define NUM235959 266
#define NUM991231 267
#define NUM99991231 268
#define NUM999999 269
#define AMPM 270
#define STD_ZONE 271
#define DST_ZONE 272
#define DST_SUFFIX 273

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 66 "dateyacc.y" /* yacc.c:355  */

    int IntVal;

#line 158 "dateyacc.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);



/* Copy the second part of user declarations.  */

#line 175 "dateyacc.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  43
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   384

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  24
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  135
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  200

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   273

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    23,     2,    20,    19,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    22,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    91,    91,    92,    96,    97,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   168,   169,   170,   171,
     172,   179,   181,   186,   187,   188,   190,   194,   195,   196,
     198,   199,   203,   209,   217,   219,   221,   226,   228,   233,
     235,   237,   242,   244,   246,   248,   250,   255,   257,   262,
     263,   264,   265,   269,   274,   278,   283,   288,   293,   298,
     303,   308,   313,   318,   323,   328,   333,   341,   351,   353,
     355,   357,   359,   361,   363,   365,   367,   369,   374,   376,
     378,   380,   382,   384,   386,   391
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DAY_NAME", "MONTH_NAME", "NUM9",
  "NUM23", "NUM59", "NUM99", "NUM2359", "NUM9999", "NUM235959",
  "NUM991231", "NUM99991231", "NUM999999", "AMPM", "STD_ZONE", "DST_ZONE",
  "DST_SUFFIX", "'.'", "'-'", "'/'", "':'", "'+'", "$accept", "num59",
  "num", "anynumber", "goal", "dayname", "date.year", "year.date",
  "yymmdd", "date", "hyphen.date", "slash.date", "year", "month.name",
  "time", "hour", "hour.alone", "am.pm", "zone", "zone.offset", "time2359", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,    46,
      45,    47,    58,    43
};
# endif

#define YYPACT_NINF -88

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-88)))

#define YYTABLE_NINF -136

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     267,   -88,     4,     9,    35,   104,    62,   -88,    78,   -88,
     -88,   -88,   -88,   -88,    39,    32,   290,    93,    93,    16,
     319,    21,    27,   183,   243,   280,   210,   239,   -88,   -88,
      11,    11,    11,    11,    11,    11,   -88,   -88,   -88,   377,
     377,   -88,   -88,   -88,   119,   357,   357,   -88,   350,   232,
     300,    35,   106,   125,   357,    44,   357,    44,   364,   106,
     -88,   350,   -88,   328,   151,   151,   106,   377,   377,   377,
     335,   -88,   260,   373,   260,   260,   -88,    61,   -88,   300,
      44,    44,   328,    -1,   -88,    18,   -88,   212,   105,   331,
     -88,    47,    48,    58,    64,   -88,   -88,    68,   -88,   -88,
     -88,   -88,   -88,   151,   377,   -88,   -88,   151,   240,   -88,
     -88,   -88,   -88,    15,    44,   -88,   357,   151,   -88,   151,
      44,   -88,   -88,    88,   -88,    89,    97,   -88,   100,   357,
     377,   377,    44,   -88,   -88,   -88,   -88,   151,   -88,   -88,
     151,   377,   -88,   174,   178,   -88,   102,   -88,   105,   105,
     -88,   -88,   -88,    11,    11,    11,    11,   151,   -88,   -88,
     -88,   -88,   -88,   -88,   -88,   377,   -88,   -88,   -88,   -88,
     -88,   -88,    11,    11,    11,    11,   -88,   -88,   -88,   -88,
     -88,   -88,   108,   -88,   -88,   -88,   -88,   -88,   -88,   309,
     -88,   -88,   -88,   -88,   -88,   -88,   -88,   -88,   -88,   -88
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    70,    71,    97,     4,     2,     3,    94,    95,    96,
     116,    82,    83,     5,     0,     0,    66,    26,    54,    81,
      15,     0,     0,     0,     0,    42,     0,    99,    72,    98,
       0,     0,     0,     0,     0,     0,     4,     2,     3,     0,
       0,    86,    84,     1,    95,    34,    39,    81,    31,     0,
       0,     0,     0,   103,    27,    29,    55,    57,     0,    93,
      92,    16,    73,    21,     0,     0,     2,     0,     0,     0,
       0,    77,     0,     0,     0,     0,    85,     2,    95,     0,
      46,    51,    43,     0,   117,   118,   122,     0,     0,   100,
     101,   106,   105,   110,   109,   115,   114,     0,    87,    91,
      89,    35,    40,    32,     0,    37,    38,    36,     0,    28,
      30,    56,    58,   103,    68,    67,    19,    17,    93,    22,
      24,    74,    76,     0,    78,     0,     0,    80,     0,    59,
       0,     0,    62,    88,    90,    49,    50,    48,    47,    52,
      44,     0,   119,   128,   131,   134,   120,   123,     0,     0,
     126,   124,   102,     0,     0,     0,     0,     0,    33,    41,
      69,    20,    18,    23,    25,     0,    60,    61,    64,    63,
      45,    53,     0,     0,     0,     0,   121,   127,   125,   108,
     107,   113,   111,    75,    79,   130,   129,   133,   132,     0,
       6,     7,     8,     9,    10,    11,    12,    13,    14,   112
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -88,   -23,     0,   -88,   -88,    99,     5,     6,   139,    33,
      73,    80,    26,    13,   153,   -88,   -88,   -88,    57,   -87,
     -88
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    13,    69,   199,    15,    16,    17,    18,    47,    71,
      21,    22,    62,    72,    25,    26,    27,    89,    90,   150,
     115
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      14,   151,     2,     3,    36,    37,    38,    91,    92,    93,
      94,    95,    96,    24,    41,  -135,    14,    37,    38,    67,
      68,    45,    46,    28,    76,    14,    23,    42,    29,    24,
      80,    81,    43,    20,    34,    58,   142,    35,    24,    97,
      99,    64,    49,     3,    36,    37,    38,     2,    65,    48,
      14,    83,    98,   100,    30,   105,   106,    31,    82,    39,
      40,   177,   178,    24,   -93,   -92,   153,   123,   126,    41,
     154,   -92,    76,   -92,   133,   134,   108,   155,   -65,    14,
     125,   128,    42,   107,   135,   136,   156,   116,   157,   120,
     121,   122,    24,  -103,  -103,  -103,     2,    34,    51,    52,
      35,  -103,    53,   129,    10,   108,   132,   -93,   165,    74,
     143,   144,   137,   -93,   145,   -93,    54,    56,    40,    61,
     176,    75,    70,    32,    79,    32,    33,   189,    33,   158,
     179,   180,   181,   182,  -103,  -103,  -103,   159,    34,    19,
     124,    35,  -103,   162,    34,   163,   152,    35,   127,   185,
     186,   187,   188,     0,   110,     0,   112,   118,    60,     7,
      78,     9,   119,   167,   168,   184,   170,     0,     0,    50,
      55,    57,   131,    63,   171,     0,    73,     0,    98,   138,
     139,   140,   141,   183,     0,     0,     2,     3,     4,    66,
      38,     0,    53,   172,    10,     0,   173,   174,   101,   102,
     175,   103,   104,    67,    68,     0,     0,   109,     0,   111,
       0,   114,     0,   160,   117,     0,     0,   143,   144,   164,
       0,   145,     0,   130,     0,    84,    85,    86,   146,   147,
      87,   169,   148,    88,     0,   149,     3,     4,    66,    38,
       0,    53,     0,    10,     3,    36,    37,    38,    36,    37,
      38,     0,    67,    68,  -104,  -104,  -104,     0,     0,  -104,
      67,    68,  -104,    74,    75,    36,    37,    38,     1,   161,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,   166,     2,     3,    36,    77,     6,     7,    78,
       9,     0,    11,    12,     3,     4,     5,     6,     7,    44,
       9,    10,    11,    12,     3,    36,    77,     6,     7,    78,
       9,     0,    11,    12,   190,   191,   192,   193,   194,   195,
     196,   197,     2,   198,    51,    59,    60,     7,    44,     9,
      10,     2,     0,     0,   118,    60,     7,    78,     9,     3,
       4,    66,    38,     0,    53,     0,    10,    85,    86,     0,
       0,    87,     0,     0,    88,    51,    59,    60,     7,    44,
       9,    10,    51,    52,     0,     0,    53,     0,    10,    51,
      52,     0,     0,   113,     0,    10,     2,     3,    36,    37,
      38,     3,    36,    37,    38
};

static const yytype_int16 yycheck[] =
{
       0,    88,     3,     4,     5,     6,     7,    30,    31,    32,
      33,    34,    35,     0,    14,     0,    16,     6,     7,    20,
      21,    16,    16,    19,    24,    25,     0,    14,    19,    16,
      25,    25,     0,     0,    19,    19,    18,    22,    25,    39,
      40,    20,    16,     4,     5,     6,     7,     3,    21,    16,
      50,    25,    39,    40,    19,    50,    50,    22,    25,    20,
      21,   148,   149,    50,     3,     3,    19,    67,    68,    69,
      22,     9,    72,    11,    74,    75,    50,    19,     0,    79,
      67,    68,    69,    50,    79,    79,    22,    61,    20,    63,
      64,    65,    79,    15,    16,    17,     3,    19,     5,     6,
      22,    23,     9,    70,    11,    79,    73,     3,    20,    20,
       5,     6,    79,     9,     9,    11,    17,    18,    21,    20,
      18,    21,    23,    19,    25,    19,    22,    19,    22,   103,
     153,   154,   155,   156,    15,    16,    17,   104,    19,     0,
      67,    22,    23,   117,    19,   119,    89,    22,    68,   172,
     173,   174,   175,    -1,    55,    -1,    57,     6,     7,     8,
       9,    10,    63,   130,   131,   165,   140,    -1,    -1,    16,
      17,    18,    73,    20,   141,    -1,    23,    -1,   165,    80,
      81,    82,    83,   157,    -1,    -1,     3,     4,     5,     6,
       7,    -1,     9,    19,    11,    -1,    22,    19,    45,    46,
      22,    48,    49,    20,    21,    -1,    -1,    54,    -1,    56,
      -1,    58,    -1,   114,    61,    -1,    -1,     5,     6,   120,
      -1,     9,    -1,    70,    -1,    15,    16,    17,    16,    17,
      20,   132,    20,    23,    -1,    23,     4,     5,     6,     7,
      -1,     9,    -1,    11,     4,     5,     6,     7,     5,     6,
       7,    -1,    20,    21,    15,    16,    17,    -1,    -1,    20,
      20,    21,    23,    20,    21,     5,     6,     7,     1,   116,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,   129,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,     5,     6,     7,     8,     9,    10,
      11,    12,     3,    14,     5,     6,     7,     8,     9,    10,
      11,     3,    -1,    -1,     6,     7,     8,     9,    10,     4,
       5,     6,     7,    -1,     9,    -1,    11,    16,    17,    -1,
      -1,    20,    -1,    -1,    23,     5,     6,     7,     8,     9,
      10,    11,     5,     6,    -1,    -1,     9,    -1,    11,     5,
       6,    -1,    -1,     9,    -1,    11,     3,     4,     5,     6,
       7,     4,     5,     6,     7
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    25,    26,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    19,    19,
      19,    22,    19,    22,    19,    22,     5,     6,     7,    20,
      21,    26,    37,     0,     9,    30,    31,    32,    33,    36,
      38,     5,     6,     9,    29,    38,    29,    38,    19,     6,
       7,    29,    36,    38,    20,    21,     6,    20,    21,    26,
      29,    33,    37,    38,    20,    21,    26,     6,     9,    29,
      30,    31,    33,    36,    15,    16,    17,    20,    23,    41,
      42,    25,    25,    25,    25,    25,    25,    26,    37,    26,
      37,    38,    38,    38,    38,    30,    31,    33,    36,    38,
      29,    38,    29,     9,    38,    44,    36,    38,     6,    29,
      36,    36,    36,    26,    34,    37,    26,    35,    37,    33,
      38,    29,    33,    26,    26,    30,    31,    33,    29,    29,
      29,    29,    18,     5,     6,     9,    16,    17,    20,    23,
      43,    43,    42,    19,    22,    19,    22,    20,    36,    33,
      29,    38,    36,    36,    29,    20,    38,    33,    33,    29,
      36,    33,    19,    22,    19,    22,    18,    43,    43,    25,
      25,    25,    25,    36,    26,    25,    25,    25,    25,    19,
       5,     6,     7,     8,     9,    10,    11,    12,    14,    27
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    24,    25,    25,    26,    26,    27,    27,    27,    27,
      27,    27,    27,    27,    27,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    28,    28,    28,
      28,    28,    28,    28,    28,    28,    28,    28,    28,    28,
      28,    29,    29,    30,    30,    30,    30,    31,    31,    31,
      31,    31,    32,    32,    33,    33,    33,    34,    34,    35,
      35,    35,    36,    36,    36,    36,    36,    37,    37,    38,
      38,    38,    38,    39,    39,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    40,    40,    40,    41,    42,    42,
      42,    42,    42,    42,    42,    42,    42,    42,    43,    43,
      43,    43,    43,    43,    43,    44
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     3,     4,     3,
       4,     2,     3,     4,     3,     4,     1,     2,     3,     2,
       3,     2,     3,     4,     2,     3,     3,     3,     3,     2,
       3,     4,     1,     2,     3,     4,     2,     3,     3,     3,
       3,     2,     3,     4,     1,     2,     3,     2,     3,     3,
       4,     4,     3,     4,     4,     1,     1,     3,     3,     4,
       1,     1,     2,     2,     3,     5,     3,     2,     3,     5,
       3,     1,     1,     1,     2,     2,     2,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     2,     3,     1,     1,     3,     3,     5,     5,     3,
       3,     5,     7,     5,     3,     3,     1,     1,     1,     2,
       2,     3,     1,     2,     2,     3,     2,     3,     1,     3,
       3,     1,     3,     3,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 65:
#line 164 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[0].IntVal) / 100;
	  yyans.minute = (yyvsp[0].IntVal) % 100;
	  yyans.second = -1;		/* unspecified */
	}
#line 1428 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 70:
#line 173 "dateyacc.y" /* yacc.c:1646  */
    { extern char *yyinbuf;
	  if (yyans.error == NULL) yyans.error = yyinbuf;
	}
#line 1436 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 71:
#line 180 "dateyacc.y" /* yacc.c:1646  */
    { yyans.c_weekday = (yyvsp[0].IntVal); }
#line 1442 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 72:
#line 182 "dateyacc.y" /* yacc.c:1646  */
    { yyans.c_weekday = (yyvsp[-1].IntVal); }
#line 1448 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 75:
#line 189 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[-4].IntVal); yyans.month = (yyvsp[-2].IntVal); }
#line 1454 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 79:
#line 197 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[0].IntVal); yyans.month = (yyvsp[-2].IntVal); }
#line 1460 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 82:
#line 204 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year  = ((yyvsp[0].IntVal) / 10000) + 1900;	/* ajs */
	  yyans.month = ((yyvsp[0].IntVal) % 10000) / 100;	/* ajs */
	  yyans.day   = ((yyvsp[0].IntVal) % 100);		/* ajs */
	}
#line 1469 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 83:
#line 210 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year  = ((yyvsp[0].IntVal) / 10000);		/* ajs */
	  yyans.month = ((yyvsp[0].IntVal) % 10000) / 100;	/* ajs */
	  yyans.day   = ((yyvsp[0].IntVal) % 100);		/* ajs */
	}
#line 1478 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 84:
#line 218 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[-1].IntVal); }
#line 1484 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 85:
#line 220 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[0].IntVal); }
#line 1490 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 86:
#line 222 "dateyacc.y" /* yacc.c:1646  */
    { yyans.month = (yyvsp[-1].IntVal); yyans.day = (yyvsp[0].IntVal); }
#line 1496 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 87:
#line 227 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[-2].IntVal); }
#line 1502 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 88:
#line 229 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[0].IntVal); }
#line 1508 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 89:
#line 234 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[-2].IntVal); }
#line 1514 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 90:
#line 236 "dateyacc.y" /* yacc.c:1646  */
    { yyans.day = (yyvsp[0].IntVal); }
#line 1520 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 91:
#line 238 "dateyacc.y" /* yacc.c:1646  */
    { yyans.month = (yyvsp[-2].IntVal); yyans.day = (yyvsp[0].IntVal); }
#line 1526 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 92:
#line 243 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year = 2000 + (yyvsp[0].IntVal); }
#line 1532 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 93:
#line 245 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year = 2000 + (yyvsp[0].IntVal); }
#line 1538 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 94:
#line 247 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year = 1900 + (yyvsp[0].IntVal); }
#line 1544 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 95:
#line 249 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year = (yyvsp[0].IntVal); }
#line 1550 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 96:
#line 251 "dateyacc.y" /* yacc.c:1646  */
    { yyans.year = (yyvsp[0].IntVal); }
#line 1556 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 97:
#line 256 "dateyacc.y" /* yacc.c:1646  */
    { yyans.month = (yyvsp[0].IntVal); }
#line 1562 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 98:
#line 258 "dateyacc.y" /* yacc.c:1646  */
    { yyans.month = (yyvsp[-1].IntVal); }
#line 1568 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 103:
#line 270 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[0].IntVal) / 100;
	  yyans.minute = (yyvsp[0].IntVal) % 100;
	  yyans.second = -1;		/* unspecified */
	}
#line 1577 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 105:
#line 279 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal);
	  yyans.minute = (yyvsp[0].IntVal);
	  yyans.second = -1;		/* unspecified */
	}
#line 1586 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 106:
#line 284 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal);
	  yyans.minute = (yyvsp[0].IntVal);
	  yyans.second = -1;		/* unspecified */
	}
#line 1595 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 107:
#line 289 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-4].IntVal);
	  yyans.minute = (yyvsp[-2].IntVal);
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1604 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 108:
#line 294 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-4].IntVal);
	  yyans.minute = (yyvsp[-2].IntVal);
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1613 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 109:
#line 299 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal);
	  yyans.minute = (yyvsp[0].IntVal);
	  yyans.second = -1;		/* unspecified */
	}
#line 1622 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 110:
#line 304 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal);
	  yyans.minute = (yyvsp[0].IntVal);
	  yyans.second = -1;		/* unspecified */
	}
#line 1631 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 111:
#line 309 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-4].IntVal);
	  yyans.minute = (yyvsp[-2].IntVal);
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1640 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 112:
#line 314 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-6].IntVal);
	  yyans.minute = (yyvsp[-4].IntVal);
	  yyans.second = (yyvsp[-2].IntVal);
	}
#line 1649 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 113:
#line 319 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-4].IntVal);
	  yyans.minute = (yyvsp[-2].IntVal);
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1658 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 114:
#line 324 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal) / 100;
	  yyans.minute = (yyvsp[-2].IntVal) % 100;
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1667 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 115:
#line 329 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[-2].IntVal) / 100;
	  yyans.minute = (yyvsp[-2].IntVal) % 100;
	  yyans.second = (yyvsp[0].IntVal);
	}
#line 1676 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 116:
#line 334 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[0].IntVal) / 10000;
	  yyans.minute = ((yyvsp[0].IntVal) % 10000) / 100;
	  yyans.second = (yyvsp[0].IntVal) % 100;
	}
#line 1685 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 117:
#line 342 "dateyacc.y" /* yacc.c:1646  */
    { if (yyans.hour < 1 || yyans.hour > 12)
	    yyans.hour = -1;		/* invalid */
	  else
	  { if (yyans.hour == 12) yyans.hour = 0;
	    yyans.hour += (yyvsp[0].IntVal);		/* 0 for AM, 12 for PM */
	} }
#line 1696 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 118:
#line 352 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1702 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 119:
#line 354 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[-1].IntVal) + 60; yyans.dst = 1; }
#line 1708 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 120:
#line 356 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1714 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 121:
#line 358 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[-1].IntVal) + 60; yyans.dst = 1; }
#line 1720 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 122:
#line 360 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 1; }
#line 1726 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 123:
#line 362 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 1; }
#line 1732 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 124:
#line 364 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1738 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 125:
#line 366 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1744 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 126:
#line 368 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = - (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1750 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 127:
#line 370 "dateyacc.y" /* yacc.c:1646  */
    { yyans.zone = - (yyvsp[0].IntVal); yyans.dst = 0; }
#line 1756 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 128:
#line 375 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[0].IntVal); }
#line 1762 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 129:
#line 377 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[-2].IntVal) + (yyvsp[0].IntVal); }
#line 1768 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 130:
#line 379 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[-2].IntVal) + (yyvsp[0].IntVal); }
#line 1774 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 131:
#line 381 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[0].IntVal); }
#line 1780 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 132:
#line 383 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[-2].IntVal) + (yyvsp[0].IntVal); }
#line 1786 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 133:
#line 385 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * (yyvsp[-2].IntVal) + (yyvsp[0].IntVal); }
#line 1792 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 134:
#line 387 "dateyacc.y" /* yacc.c:1646  */
    { (yyval.IntVal) = 60 * ((yyvsp[0].IntVal) / 100) | ((yyvsp[0].IntVal) % 100); }
#line 1798 "dateyacc.c" /* yacc.c:1646  */
    break;

  case 135:
#line 392 "dateyacc.y" /* yacc.c:1646  */
    { yyans.hour   = (yyvsp[0].IntVal) / 100;	/* ajs */
	  yyans.minute = (yyvsp[0].IntVal) % 100;	/* ajs */
	  yyans.second = -1;		/* ajs */
	}
#line 1807 "dateyacc.c" /* yacc.c:1646  */
    break;


#line 1811 "dateyacc.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 398 "dateyacc.y" /* yacc.c:1906  */

